//----------------------------------------------------------------------------
//
//
//----------------------------------------------------------------------------
/*
 *
 * Modified: $Date$
 *
 * Author: Klaus Gotthardt
 *
 * Copyright (c) 1998-2001 Klaus Gotthardt
 * All rights reserved.
*/

import java.net.URL;
import java.sql.*;
import java.io.*;
import java.util.*;
import java.util.Date;
import java.text.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import org.apache.fop.apps.Driver;
import org.apache.fop.apps.Version;


public class DBtoPDF extends HttpServlet {


public boolean DEBUG; 
private String properties;

public void init (ServletConfig config) throws ServletException
{
// This method initializes the servlet and only gets call once.
// Allocate all of the servlet resources here.
	super.init (config);
	properties = config.getInitParameter("properties");
	ServletContext context=config.getServletContext();
	ConnectionPoolObject cpo=new ConnectionPoolObject();
	cpo.startTimer();
	context.setAttribute("currentConnections",cpo);
	System.out.println("DBtpPDF.init()");
}

public void destroy (ServletConfig config) throws ServletException
{
// This method initializes the servlet and only gets call once.
// Allocate all of the servlet resources here.
	ServletContext context=config.getServletContext();
	ConnectionPoolObject cpo=new ConnectionPoolObject();
	cpo.closeAll();
	cpo.stopTimer();
	System.out.println("DBtoPDF.destroy()");
}

// void 
// public synchronized void service (HttpServletRequest req, HttpServletResponse res)
public              void service (HttpServletRequest req, HttpServletResponse res)
throws ServletException, IOException    {


	String args[]; 
	StringBuffer outSB = new StringBuffer ();

	if (req.getParameter("debug")==null)  { DEBUG=false ;} 
	else { DEBUG=true;}

	if (DEBUG) outSB.append("<p>Properties from servlet init: " + properties);

   String props; 
 	if (properties==null) {
		props = getServletContext().getRealPath(req.getParameter("p"));
		if (DEBUG) outSB.append("<p>Properies from html: " + props);
	} 
	else {
		props = properties;
	}

   if (DEBUG) outSB.append("<Realpath: "+getServletContext().getRealPath(req.getParameter("p")));

	
  	Properties applicationProps = new Properties();
	if (props==null) {
	   outHTML("<p>no properties entered ",res);
 
   } else {
 	   try {
      	// String path = context.getRealPath("/WEB-INF/myconfig.dat");
	  	   FileInputStream appStream = new FileInputStream(props);
		   // FileInputStream appStream = new FileInputStream(getServletContext().getRealPath(props));
		   applicationProps.load(appStream);
		   appStream.close();
	   } catch (Exception ex) {
		   outHTML("Cannot find properties file:" + props + " error: " + ex.toString() 
		   + " realpath: "+getServletContext().getRealPath(req.getParameter("p")),res);
      }  
		if (DEBUG) outSB.append("Properties affected: " + props );
   }
	
	String servletName=req.getRequestURI();
   String driver = null;
   String url = null;
   String user = null;
   String password = null;
	String c = null;
	String q = null;

	String queryName = req.getParameter("q");  //  query-string
	if (queryName != null) {
	      if (applicationProps.get(queryName) != null)  {
	      	q = (String)applicationProps.get(queryName);
   		   if (DEBUG) outSB.append("<p> q (query) " + queryName + " : " + q  );
		   } else {
		      outHTML("Query not found in DBtoPDF.properties: "+queryName,res);
         }
	}
	
	//  replace %paramname%  by the value in query-String ....
	
	String cName = req.getParameter("c");  //  connection string
	if (cName != null) {
      if (applicationProps.get(cName) != null)  {
   	   c = (String)applicationProps.get(cName) ;
         StringTokenizer st = new StringTokenizer(c, ",");
	      driver = st.nextToken();
	      url = st.nextToken();
	      user = st.nextToken();
	      password = st.nextToken();
	   } else {
	       outHTML("Connection not found in DBtoPDF.properties :  " + cName,res);
	   }
	}      

	if (DEBUG) outSB.append("<p> connectionstring " + cName + " : " + c);

	String x = null;
	x = req.getParameter("x");
	
	if (DEBUG) outSB.append("<p>replace names ");
	Enumeration e = req.getParameterNames();
	if (e.hasMoreElements()) {
		while (e.hasMoreElements()) {
			String element = (String)e.nextElement();
			String param = req.getParameter(element);
			String name = "%"+element+"%";
			if (DEBUG)   outSB.append("<p>param    "+name+"   =    "+param);
			if (q != null) q = subst(q,name,param);      
	
			if (user != null) user = subst(user,name,param);      
 			if (password != null) password = subst(password,name,param);      
  
		}
	}

	// out.flush();
	if (DEBUG) outSB.append("<p> SQL: " + q );
 	Connection con = null;
	ServletContext context=getServletContext();
	ConnectionPoolObject cpo=new ConnectionPoolObject();
   cpo=(ConnectionPoolObject)context.getAttribute("currentConnections");
  	HttpSession session = req.getSession(true); 

  	try {
      
       if ((!req.getRemoteAddr().startsWith("141.2.155."))
       && (!req.getRemoteAddr().startsWith("141.2.107."))
       && (!req.getRemoteAddr().equals("127.0.0.1"))
       ) {outHTML("access denied",res);}
       else
       if (c != null && q != null) {  
	       if (DEBUG) outSB.append("<p> c != null && q != null ");
            con = cpo.getConnection(driver,url,user,password);  // new connection or conn. from pool
 			   if (con == null) {
			       outHTML("Cannot connnect to database, userid or password not valid",res);
 	         } else {
	             if (DEBUG) outSB.append("<p> connection from pool ");
            }
	    } else if (c != null) {
	      if (DEBUG) outSB.append("<p> login ");
            con = cpo.getConnection(driver,url,user,password);  // login only
 		      if (con == null) {
			       outHTML("Username or password not valid ",res);
	  	      } else {
                outHTML("Connnected",res);
  	             session.putValue("DBtoPDF.url", url);           
                session.putValue("DBtoPDF.user", user); 
            }
       } else if (q != null) {
	      if (DEBUG) outSB.append("<p> only query ");
     		url = (String)session.getValue("DBtoPDF.url");    // get seeionobject
 			user = (String)session.getValue("DBtoPDF.user"); 
			con = cpo.takeFromPool(url,user);                     // connection from pool
  			if (con == null) {
				outHTML("Not connnected, please login",res);
	   	} 
       } else if (x != null) {
	      if (DEBUG) outSB.append("<p> logout only  ");
     		url = (String)session.getValue("DBtoPDF.url");    // get seeionobject
 			user = (String)session.getValue("DBtoPDF.user"); 
 	       	cpo.closeConnection(url,user); 
				outHTML(x,res);
  	         session.removeValue("DBtoPDF.url");
 	         session.removeValue("DBtoPDF.user");
	 			if (DEBUG) outSB.append("<p>  session.removeValue    ");

       } 
 
    if (con != null) {	
	      if (DEBUG) outSB.append("<p> con != null ");
   		DatabaseMetaData dma = con.getMetaData ();
			Statement stmt = con.createStatement ();
			if (q != null) {
            if (DEBUG) outSB.append("<p> q != null ");
     
               stmt.executeQuery(q);
       //			stmt.execute (q);
					ResultSet rs = stmt.getResultSet();
					if (rs != null) {
				       String foString=dispResultSetPDF(req,rs);
				       // System.out.println(foString);
            	     renderFO(new InputSource(new StringReader(foString)), res);
					}
					rs.close();
					if (DEBUG) outSB.append("resultset.close");
			}
			
			stmt.close();
			if (DEBUG) outSB.append("stm.close");
 		   // con.close();
		   cpo.putConnection(url,user,con,5*60*1000);
			if (DEBUG) outSB.append("<p> connection put to pool  ");
		 }
	}
	catch (SQLException ex) {
		// A SQLException was generated.  Catch it and
		// display the error information.  Note that there
		// could be multiple error objects chained
		// together
		//          ServletOutputStream out = res.getOutputStream();
		outSB.append ("<p>*** SQLException caught ***\n");
		while (ex != null) {
			outSB.append("<p>query= " + q ); 
			outSB.append ("<p>SQLState: " +
			ex.getSQLState ());
			outSB.append ("<p>Message:  " +
			ex.getMessage ());
			outSB.append ("<p>Vendor:   " +
			ex.getErrorCode ());
			ex = ex.getNextException ();
			outSB.append ("<p>");
         outHTML(outSB.toString(),res);
 
		}
	}
	catch (java.lang.Exception ex) {
		
		 // Got some other type of exception.  Dump it.
		// outSB.append("<p>java.lang.Exeption");
  
	 		outHTML(ex.toString(),res);
         
	
		// ex.printStackTrace();
	}  // end catch
	
	finally {
		if (DEBUG) 	         outHTML(outSB.toString(),res);
/*
		ServletOutputStream out = res.getOutputStream();
	//	out.println(outSB.toString());
		out.flush();
	
		out.close();
  */   
      
 
	}
}//DoGet

//-------------------------------------------------------------------
// subst: substitute substring  subst("klaus klein","kl","m") ->   "maus mein" 
//-------------------------------------------------------------------
private static String subst (String s, String search, String replace)  {
	StringBuffer sb = new StringBuffer ();
	int i = 0;
	int j = 0;
	int l = search.length();
	while (j > -1) {
	   j = s.indexOf(search,i);
	   if (j > -1)  {
		   sb.append (s.substring(i,j));
		   sb.append (replace);
		   i = j + l;
		}    
	}
	sb.append (s.substring(i,s.length()));
	return sb.toString();
}


private  String dispResultSetPDF (HttpServletRequest req,ResultSet rs) throws SQLException, java.io.IOException {
   int margin_right=10;
   if (req.getParameter("marginright") != null)  margin_right = Integer.parseInt(req.getParameter("marginright"));
   int margin_left=24;
   if (req.getParameter("marginleft") != null)  margin_left = Integer.parseInt(req.getParameter("marginleft"));
   int margin_top=15;
   if (req.getParameter("margintop") != null)  margin_top = Integer.parseInt(req.getParameter("margintop"));
   int margin_bottom=15;
   if (req.getParameter("marginbottom") != null)  margin_bottom = Integer.parseInt(req.getParameter("marginbottom"));
   int page_width=210; 
   if (req.getParameter("pagewidth") != null)  page_width = Integer.parseInt(req.getParameter("pagewidth"));
   int page_height=297; 
   if (req.getParameter("pageheight") != null)  page_height = Integer.parseInt(req.getParameter("pageheight"));
   
   int font_size=10; 
   if (req.getParameter("fontsize") != null)  font_size = Integer.parseInt(req.getParameter("fontsize"));
   int font_size_title=font_size+2; 

   int region_before=(int)(font_size*1.2+10);
   if (req.getParameter("regionbefore") != null)  region_before = Integer.parseInt(req.getParameter("regionbefore"));
   int region_after=(int)(font_size*0.6+10);
   if (req.getParameter("regionafter") != null)  region_after = Integer.parseInt(req.getParameter("regionafter"));

   int layout=0; 
   if (req.getParameter("layout") != null)  layout = Integer.parseInt(req.getParameter("layout"));
   
   String color="black"; 
   if (req.getParameter("color") != null)  color = (String)req.getParameter("color");
 

   String font_family="sans-serif"; 
   if (req.getParameter("fontfamily") != null)  font_family = (String)req.getParameter("fontfamily");
   
   String font_style="italic"; 
   if (req.getParameter("fontstyle") != null)  font_style = (String)req.getParameter("fontstyle");
   
   String title="DBtoPDF"; 
   if (req.getParameter("title") != null)  title = (String)req.getParameter("title");

   String lang = req.getParameter("lang");
   if (lang == null) lang = req.getHeader("Accept-Language");
   Date today;
   String dateOut;
   DateFormat dateFormatter;
   dateFormatter = 
         DateFormat.getDateInstance(DateFormat.LONG, new Locale(lang,""));
   today = new Date();
   dateOut = dateFormatter.format(today);

   String page="Page"; 
   if (lang.equals("de"))   page = "Seite";
   if (lang.equals("fr"))   page = "Numro";
   if (lang.equals("it"))   page = "Pagina";
   if (req.getParameter("page") != null)  page = (String)req.getParameter("page");

// String footer=" created with DBtoPDF    http://www.kgo.de";
String footer="";


 	StringBuffer sb = new StringBuffer();
	ResultSetMetaData md = rs.getMetaData ();
   int numCols = md.getColumnCount ();
   int width=page_width-margin_left-margin_right;
   int displaySize=0;
	int width2=width/2;




   for (int i=1; i<= numCols; i++) {    // label
	   displaySize += md.getColumnDisplaySize(i);
	};
   StringBuffer columnwidths = new StringBuffer();
   StringBuffer headers = new StringBuffer();
   int tempwidth=width;
   for (int i=1; i<= numCols; i++) {    // label
	   int w=(md.getColumnDisplaySize(i)*width)/(displaySize*2)+width/(numCols*2)+1;
	 //  tempwidth -= w;
	 //  if (i == numCols+1) w=width-tempwidth;  //rest to last field
	   // int w=width/numCols;
	   columnwidths.append("<fo:table-column column-width=\""+w+"mm\"/>");
   	if (md.getColumnType(i) == 1 || md.getColumnType(i) == -1 || md.getColumnType(i) == 12) {
   	   headers.append("<fo:table-cell><fo:block text-align=\"start\">"
	      +          md.getColumnLabel(i) + "</fo:block></fo:table-cell>");
		} else {
		   headers.append("<fo:table-cell><fo:block text-align=\"end\">"
	      +          md.getColumnLabel(i) + " </fo:block></fo:table-cell>");
		}
   };

   StringBuffer rows = new StringBuffer();
   int sw = 0;
   String tempHTML;
   while ( rs.next() ) {      //  values
		if (sw == 1 ) {
			sw = 0;
		}
		else {
			sw = 1;
		}
		rows.append("<fo:table-row>");

		for(int i=1; i<= numCols; i++) {
			if (md.getColumnType(i) == 1 || md.getColumnType(i) == -1 || md.getColumnType(i) == 12) {
				rows.append( "<fo:table-cell ><fo:block space-before.optimum=\"1mm\" text-align=\"start\"><![CDATA["+rs.getString(i)+"]]></fo:block></fo:table-cell>");
			} 
			else {
				rows.append( "<fo:table-cell ><fo:block space-before.optimum=\"1mm\" text-align=\"end\"><![CDATA["+rs.getString(i)+" ]]></fo:block></fo:table-cell>");
			} 
		}
		rows.append("</fo:table-row>");
   }




sb.append("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>"
+         "<fo:root xmlns:fo=\"http://www.w3.org/1999/XSL/Format\">"
+         "<fo:layout-master-set>"
+         "<fo:simple-page-master"
+         " margin-right=\""+margin_right+"mm\""
+         " margin-left=\""+margin_left+"mm\""
+         " margin-top=\""+margin_top+"mm\""
+         " margin-bottom=\""+margin_bottom+"mm\""
+         " page-height=\""+page_height+"mm\""
+         " page-width=\""+page_width+"mm\">"
+         "<fo:region-before extent=\""+region_before+"mm\"/>"
+         "<fo:region-body margin-top=\""+region_before+"mm\"" 
+         " margin-bottom=\""+region_after+"mm\"/>"
+         "<fo:region-after extent=\""+region_after+"mm\"/>"
+         "</fo:simple-page-master>"
+         "</fo:layout-master-set>"
+         "<fo:page-sequence>");

if (layout == 1) {

//  region-before

sb.append("<fo:static-content flow-name=\"xsl-region-before\">"

+ "<fo:block font-size=\""+font_size_title+"pt\" font-family=\""+font_family+"\" font-weight=\"bold\""
+ " space-after.optimum=\"0pt\" background-color=\""
+ color+ "\""
+ " color=\"white\" text-align=\"center\" padding-top=\"3pt\">"
+ title+"</fo:block>"

+         "<fo:block space-before.optimum=\"6pt\" font-size=\""+font_size+"pt\"" 
+         " font-family=\""+font_family+"\" font-weight=\"bold\""
+         ">"
+         "<fo:table  >"
+         columnwidths.toString()
+         "<fo:table-body>"
+         "<fo:table-row>"
+         headers.toString()
+         "</fo:table-row>"
+         "</fo:table-body>"
+         "</fo:table>"
+         "</fo:block>"
+         "<fo:block>" 

+         "<fo:leader leader-pattern=\"rule\" color=\""
+         color
+         "\" space-before.optimum=\"0pt\"" 
+         " space-after.optimum=\"0pt\" rule-thickness=\"3pt\" start-indent=\"0pt\"/>"

+         "</fo:block>"



+         "</fo:static-content>");

// region-after
sb.append("<fo:static-content flow-name=\"xsl-region-after\">"

+ "<fo:block font-size=\""+font_size+"pt\" font-family=\""+font_family+"\" font-weight=\"bold\""
+ " space-after.optimum=\"0pt\" background-color=\""
+ color+ "\""
+ " color=\"white\" text-align=\"center\" padding-top=\"3pt\">"

+         "<fo:table space-before.optimum=\"0pt\">"
+         "<fo:table-column column-width=\""+width2+"mm\"/>"
+         "<fo:table-column column-width=\""+width2+"mm\"/>"
+         "<fo:table-body>"
+         "<fo:table-row>"
+         "<fo:table-cell ><fo:block text-align=\"start\">"+dateOut+footer
// +         "<fo:basic-link external-destination=\"http://www.kgo.de\"> www.kgo.de</fo:basic-link>"
+         "</fo:block>"
+         "</fo:table-cell>"
+         "<fo:table-cell ><fo:block text-align=\"end\">"+ page+" <fo:page-number/></fo:block>"
+         "</fo:table-cell>"
+         "</fo:table-row>"
+         "</fo:table-body>"
+         "</fo:table>"
+         "</fo:block>"

+         "</fo:static-content>");



} else {
//  region-before
sb.append("<fo:static-content flow-name=\"xsl-region-before\">"
+         "<fo:block>" 
+         "<fo:leader leader-pattern=\"rule\" space-before.optimum=\"0pt\"" 
+         " color=\""+color+"\""
+         " space-after.optimum=\"0pt\" rule-thickness=\"0.5pt\" start-indent=\"0pt\"/></fo:block>"

+         "<fo:block"
+         " color=\""+color+"\""
+         " font-size=\""+font_size_title+"pt\" font-family=\""+font_family+"\" font-weight=\"bold\""
+         ">"
+         title+"</fo:block>"

+         "<fo:block space-before.optimum=\"6pt\" font-size=\""+font_size+"pt\"" 
+         " font-family=\""+font_family+"\" font-weight=\"bold\""
+         ">"
+         "<fo:table  >"
+         columnwidths.toString()
+         "<fo:table-body>"
+         "<fo:table-row>"
+         headers.toString()
+         "</fo:table-row>"
+         "</fo:table-body>"
+         "</fo:table>"
+         "</fo:block>"
+         "<fo:block>" 

+         "<fo:leader leader-pattern=\"rule\" space-before.optimum=\"0pt\"" 
+         " color=\""+color+"\""
+         " space-after.optimum=\"0pt\" rule-thickness=\"0.5pt\" start-indent=\"0pt\"/></fo:block>"

+         "</fo:static-content>"

// region-after
+         "<fo:static-content flow-name=\"xsl-region-after\">"
+         "<fo:block><fo:leader leader-pattern=\"rule\" space-before.optimum=\"0pt\""
+         " color=\""+color+"\""
+         " space-after.optimum=\"0pt\" rule-thickness=\"0.5pt\" start-indent=\"0pt\"/></fo:block>"

+         "<fo:block font-size=\""+font_size+"pt\" font-family=\""+font_family+"\""
+         ">"
+         "<fo:table space-before.optimum=\"0pt\">"
+         "<fo:table-column column-width=\""+width2+"mm\"/>"
+         "<fo:table-column column-width=\""+width2+"mm\"/>"
+         "<fo:table-body>"
+         "<fo:table-row>"
+         "<fo:table-cell ><fo:block text-align=\"start\">"+dateOut+footer
// +         "<fo:basic-link external-destination=\"http://www.kgo.de\"> www.kgo.de</fo:basic-link>"
+         "</fo:block>"
+         "</fo:table-cell>"
+         "<fo:table-cell ><fo:block text-align=\"end\">"+ page+" <fo:page-number/></fo:block>"
+         "</fo:table-cell>"
+         "</fo:table-row>"
+         "</fo:table-body>"
+         "</fo:table>"
+         "</fo:block>"
+         "</fo:static-content>");
}

// region-body
sb.append("<fo:flow flow-name=\"xsl-region-body\">"
+         "<fo:block font-size=\""+font_size+"pt\" font-family=\""+font_family+"\""
+         ">"
+         "<fo:table>"
+         columnwidths.toString()
+         "<fo:table-body>"
+         rows.toString()
+         "</fo:table-body>"
+         "</fo:table>"
+         "</fo:block>"
+         "</fo:flow>"

+         "</fo:page-sequence>"
+         "</fo:root>");

//	sb.append( "</table> " );
   return sb.toString();
}//dispResultSet



public void outHTML (String str, HttpServletResponse res) {
 try{
	// System.out.println("outHTML"+str);
	 	StringBuffer outSB = new StringBuffer();
	outSB.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">");
	outSB.append("<HTML><HEAD><TITLE> DBtoPDF Output </TITLE></HEAD><BODY>");
   outSB.append(str);
   outSB.append("</BODY></HTML>");
   res.setContentType("text/html");
	res.setHeader("Pragma","no-cache");
	res.setHeader("Cache-Control","no-cache");
	res.setHeader("Expires","0");
	ServletOutputStream out = res.getOutputStream();
	out.println("<H4>"+outSB.toString()+"</H4>");
	out.flush();
//	out.close();
	
 } catch (Exception ex) {
	 ex.printStackTrace();
}



}

public void renderFO(InputSource foFile, HttpServletResponse res) 
	throws ServletException
    {
	try {

	    ByteArrayOutputStream out = new ByteArrayOutputStream();
	res.setHeader("Pragma","no-cache");
	res.setHeader("Cache-Control","no-cache");
	res.setHeader("Expires","0");

	    
	    res.setContentType("application/pdf");
	    
	    Driver driver = new Driver(foFile, out);
	    driver.run();

	    byte[] content = out.toByteArray();
	    res.setContentLength(content.length);
	    res.getOutputStream().write(content);
	    res.getOutputStream().flush();

   
	}
	catch (Exception ex) {
				 ex.printStackTrace();
	}
}


}
